#include <dshow.h>
#include "resource.h"

#pragma comment(lib,"strmiids.lib")

#define MYWNDTITLE		"DX9_Show"
#define MYWNDCLASS		"CLASS_DX9_Show"
#define WIDTH			320 			// ʂ̏TCYij
#define HEIGHT			320 			// ʂ̏TCYicj
#define RELEASE(p)		if (p){p->Release();p=NULL;}

IGraphBuilder	*g_pGB = NULL;
IVideoWindow	*g_pVW = NULL;
IMediaControl	*g_pMC = NULL;
bool			g_bAudioOnly = FALSE;

bool	Open_FileDlg(HWND hWnd);
bool	Load(HWND hWnd, char *filename);
void	Cleanup();

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		if(FAILED(CoInitialize(NULL))){
			MessageBox(hWnd,"COM ̏Ɏs܂",MYWNDTITLE,MB_OK);
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		}
		break;
		
	case WM_MOVE:
	case WM_SIZE:
		if(!g_bAudioOnly){
			InvalidateRect(hWnd,0,0);
		}
		break;
		
	case WM_KEYDOWN:
		switch (wParam)
		{
		case VK_ESCAPE:
			SendMessage(hWnd,WM_CLOSE,0,0);
			break;
		}
		break;
		
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDM_OPEN:
			Open_FileDlg(hWnd);
			break;
		}
		break;
		
	case WM_CLOSE:
		DestroyWindow(hWnd);
		Cleanup();
		PostQuitMessage(0);
		break;
		
	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}// WndProc

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;
	
	HMENU hMenu = LoadMenu(hInst,MAKEINTRESOURCE(IDR_MENU1));
	
	hWnd = CreateWindowEx(WS_EX_CLIENTEDGE, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, WIDTH, HEIGHT,
				NULL,
				hMenu,
				hInst,
				NULL);

	if(hWnd == NULL)
		return 0;

	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

// I[vt@C_CAO
bool Open_FileDlg(HWND hWnd)
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH] = "";
	
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.Flags = OFN_HIDEREADONLY; 
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	//tB^w肷ƂB
	ofn.lpstrFilter =	"fBAt@C\0" "*.avi;*mpg;*.mpeg;*.mov;*.wmv;*.wav;*.wma;*.au;*.aif;*.mid;*.mp3;*.midi;*.bmp;*.gif;*.jpg;*.jpeg;*.png;*.tif\0" 
						"t@C (*.avi; *.mpg; *.mpeg; *.mov; *.wmv)\0" "*.avi;*mpg;*.mpeg;*.mov;*.wmv\0" 
						"yt@C (*.wav; *.wma; *.au; *.aif; *.mid; *.mp3; *.midi)\0" "*.wav;*.wma;*.au;*.aif;*.mid;*.mp3;*.midi\0" 
						"摜t@C (*.bmp; *.gif; *.jpg; *.jpeg)\0" "*.bmp;*.gif;*.jpg;*.jpeg\0" 
						"ׂẴt@C (*.*)\0" "*.*\0";
	ofn.nFilterIndex = 1;
	if(GetOpenFileName(&ofn)){
		return(Load(hWnd, fn));
	}
	return TRUE;
}// Open_FileDlg

// t@C̓ǂݍ
bool Load(HWND hWnd, char *filename)
{	
	WCHAR wfilename[MAX_PATH];
	MultiByteToWideChar(CP_ACP, 0, filename, -1, wfilename, MAX_PATH);
	RELEASE(g_pGB);
	HRESULT hr;
	hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER,
						  IID_IGraphBuilder, (void **)&g_pGB);
	if(FAILED(hr)){
		return FALSE;
	}
	if(FAILED(g_pGB->RenderFile(wfilename, NULL))){
		return FALSE;
	}
	RELEASE(g_pVW);
	if(FAILED(g_pGB->QueryInterface(IID_IVideoWindow, (void **)&g_pVW))){
		return FALSE;
	}
	if(FAILED(g_pVW->put_MessageDrain((OAHWND)hWnd))){
		g_bAudioOnly = TRUE;
		RELEASE(g_pVW);
	}
	else{
		g_bAudioOnly = FALSE;
	}
	if(!g_bAudioOnly){	// 摜Et@ĈƂ
		if(FAILED(g_pVW->put_Owner((OAHWND)hWnd))){
			return FALSE;
		}
		if(FAILED(g_pVW->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS))){
			return FALSE;
		}
		long		v_wdh,v_hgt;
		IBasicVideo	*pBV;
		if(FAILED(g_pGB->QueryInterface(IID_IBasicVideo, (void**)&pBV))){
			return FALSE;
		}
		pBV->GetVideoSize(&v_wdh, &v_hgt);
		RELEASE(pBV);
		RECT		rc;
		int		edge_wdh,edge_hgt,border_wdh,border_hgt,menu_hgt,title_hgt;
		GetWindowRect(hWnd, &rc);
		edge_wdh  = GetSystemMetrics(SM_CXEDGE);
		edge_hgt  = GetSystemMetrics(SM_CYEDGE);
		border_wdh = GetSystemMetrics(SM_CXBORDER);
		border_hgt = GetSystemMetrics(SM_CYBORDER);
		title_hgt = GetSystemMetrics(SM_CYCAPTION);
		menu_hgt  = GetSystemMetrics(SM_CYMENU);
		MoveWindow(hWnd, rc.left, rc.top, v_wdh+edge_wdh*4+border_wdh*2,
					v_hgt+edge_hgt*4+border_hgt*2+title_hgt+menu_hgt, TRUE);
		g_pVW->SetWindowPosition(0, 0, v_wdh, v_hgt);
	}
	RELEASE(g_pMC);
	if(FAILED(g_pGB->QueryInterface(IID_IMediaControl, (void**)&g_pMC))){
		return FALSE;
	}
	if(FAILED(g_pMC->Run())){
		return FALSE;
	}
	return TRUE;
}// Load

// IuWFNg̉
void Cleanup()
{
	if(g_pVW){
		g_pVW->put_Visible(OAFALSE);
		g_pVW->put_Owner(NULL);
	}
	RELEASE(g_pMC);
	RELEASE(g_pVW);
	RELEASE(g_pGB);
	CoUninitialize();
}// Cleanup
